/**
 * $Id: editor_plugin_src.js 201 2007-02-12 15:56:56Z spocke $
 *
 * @author Moxiecode
 * @copyright Copyright  2004-2007, Moxiecode Systems AB, All rights reserved.
 * Modified for E-Blah by Justin
 */

(function() {
	tinymce.create('tinymce.plugins.BBCodePlugin', {
		init : function(ed, url) {
			var t = this, dialect = ed.getParam('bbcode_dialect', 'punbb').toLowerCase();

			ed.onBeforeSetContent.add(function(ed, o) {
				o.content = t['_' + dialect + '_bbcode2html'](o.content);
			});

			ed.onPostProcess.add(function(ed, o) {
				if (o.set)
					o.content = t['_' + dialect + '_bbcode2html'](o.content);

				if (o.get)
					o.content = t['_' + dialect + '_html2bbcode'](o.content);
			});
		},

		getInfo : function() {
			return {
				longname : 'BBCode Plugin',
				author : 'Moxiecode Systems AB',
				authorurl : 'http://tinymce.moxiecode.com',
				infourl : 'http://wiki.moxiecode.com/index.php/TinyMCE:Plugins/bbcode',
				version : tinymce.majorVersion + "." + tinymce.minorVersion
			};
		},

		// Private methods

		// HTML -> BBCode in PunBB dialect
		_punbb_html2bbcode : function(s) {
			s = tinymce.trim(s);

			function rep(re, str) {
				s = s.replace(re, str);
			};

			// example: <strong> to [b]
			rep(/<a.*?href=\"(.*?)\".*?>(.*?)<\/a>/gi,"[url=$1]$2[/url]");
			rep(/<span style=\"color: ?(.*?);\">(.*?)<\/span>/gi,"[color=$1]$2[/color]");
			rep(/<font.*?color=\"(.*?)\".*?>(.*?)<\/font>/gi,"[color=$1]$2[/color]");
			rep(/<font.*?style=\"font-size: (.*?)px\".*?>(.*?)<\/font>/gi,"[size=$1]$2[/size]");
			rep(/<font.*?size=\"1\".*?>(.*?)<\/font>/gi,"[size=8]$1[/size]");
			rep(/<font.*?size=\"2\".*?>(.*?)<\/font>/gi,"[size=10]$1[/size]");
			rep(/<font.*?size=\"3\".*?>(.*?)<\/font>/gi,"[size=12]$1[/size]");
			rep(/<font.*?size=\"4\".*?>(.*?)<\/font>/gi,"[size=14]$1[/size]");
			rep(/<font.*?size=\"5\".*?>(.*?)<\/font>/gi,"[size=18]$1[/size]");
			rep(/<font.*?size=\"6\".*?>(.*?)<\/font>/gi,"[size=24]$1[/size]");
			rep(/<font.*?size=\"7\".*?>(.*?)<\/font>/gi,"[size=36]$1[/size]");
			rep(/<font.*?face=\"(.*?)\".*?>(.*?)<\/font>/gi,"[face=$1]$2[/face]");
			rep(/<span style=\"font-size:(.*?)px\">(.*?)<\/span>/gi,"[size=$1]$2[/size]");
			rep(/<span style=\"font-size:1\">(.*?)<\/span>/gi,"[size=8]$1[/size]");
			rep(/<span style=\"font-size:2\">(.*?)<\/span>/gi,"[size=10]$1[/size]");
			rep(/<span style=\"font-size:3\">(.*?)<\/span>/gi,"[size=12]$1[/size]");
			rep(/<span style=\"font-size:4\">(.*?)<\/span>/gi,"[size=14]$1[/size]");
			rep(/<span style=\"font-size:5\">(.*?)<\/span>/gi,"[size=18]$1[/size]");
			rep(/<span style=\"font-size:6\">(.*?)<\/span>/gi,"[size=24]$1[/size]");
			rep(/<span style=\"font-size:7\">(.*?)<\/span>/gi,"[size=36]$1[/size]");
			rep(/<font>(.*?)<\/font>/gi,"$1");
			rep(/<strike>(.*?)<\/strike>/gi,"[s]$1[/s]");

			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/angry.gif\".*?\/>', 'gi') ,">:(");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/sad.gif\".*?\/>', 'gi') ,":(");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/huh.gif\".*?\/>', 'gi') ,"??)");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/roll.gif\".*?\/>', 'gi') ,"::)");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/lol.gif\".*?\/>', 'gi') ,":D");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/kiss.gif\".*?\/>', 'gi') ,":K)");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/cool.gif\".*?\/>', 'gi') ,"8)");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/blush.gif\".*?\/>', 'gi') ,":B");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/shock.gif\".*?\/>', 'gi') ,":o");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/undecided.gif\".*?\/>', 'gi') ,":-/");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/lipsx.gif\".*?\/>', 'gi') ,":X");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/cry.gif\".*?\/>', 'gi') ,":'(");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/grin.gif\".*?\/>', 'gi') ,";D");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/tongue.gif\".*?\/>', 'gi') ,":P");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/wink.gif\".*?\/>', 'gi') ,";)");
			rep( RegExp('<img src=\"' + tinyMCE.activeEditor.getParam('smileyurl') + '/smiley.gif\".*?\/>', 'gi') ,":)");

			rep(/<img.*?src=\"(.*?)\".*?\/>/gi,"[img]$1[/img]");

			rep(/<\/(strong|b)>/gi,"[/b]");
			rep(/<(strong|b)>/gi,"[b]");
			rep(/<\/(em|i)>/gi,"[/i]");
			rep(/<(em|i)>/gi,"[i]");
			rep(/<\/u>/gi,"[/u]");
			rep(/<span style=\"text-decoration: ?underline;\">(.*?)<\/span>/gi,"[u]$1[/u]");
			rep(/<u>/gi,"[u]");

			//rep(/<div class=\"win quotebody\">Quoted from (.*?)(<br \/>|<br>|<br\/>)(.*?)<\/div>/gi,"[quote=$1]$3[/quote]");
			//rep(/<div class=\"win quotebody\">(.*?)<\/div>/gi,"[quote]$1[/quote]");

			rep(/<p.*?style=\"text-align: ?(justify|right|center);\">(.*?)$/gi,"[$1]$2[/$1]");
			rep(/<p.*?align=\"(justify|right|center)\">(.*?)$/gi,"[$1]$2[/$1]");
			rep(/<p.*?align=\"left\">/gi,"");
			rep(/<p.*?align=\"(justify|right|center|left)\">/gi,"");
			rep(/<p.*?style=\"text-align: ?left;\">/gi,"");

			rep(/<br \/>/gi,"\n\n");
			rep(/<br\/>/gi,"\n\n");
			rep(/<br>/gi,"\n\n");

			rep(/<p.*?align=\"(justify|right|center)\">(.*?)$/gi,"[$1]$2[/$1]");

			rep(/<hr \/>/gi,"[hr]");
			rep(/<p.*?>/gi,"");
			rep(/<sub>/gi,"[sub]");
			rep(/<sup>/gi,"[sup]");
			rep(/<(div|\/div)>/gi,"");
			rep(/<\/sub>/gi,"[/sub]");
			rep(/<\/sup>/gi,"[/sup]");
			rep(/<ul>/gi,"[list]");
			rep(/<\/li>/gi,"");
			rep(/<li>/gi,"[*]");
			rep(/<\/ul>/gi,"[/list]");
			rep(/<\/p>/gi,"\n");
			rep(/&nbsp;/gi," ");
			rep(/&quot;/gi,"\"");
			rep(/&lt;/gi,"<");
			rep(/&gt;/gi,">");
			rep(/&amp;/gi,"&");

			return s; 
		},

		// BBCode -> HTML from E-Blah dialect
		_punbb_bbcode2html : function(s) {
			s = tinymce.trim(s);

			function rep(re, str) {
				s = s.replace(re, str);
			};

			rep(/\n/gi,"<br />");
			rep(/\[b\]/gi,"<strong>");
			rep(/\[\/b\]/gi,"</strong>");
			rep(/\[i\]/gi,"<em>");
			rep(/\[\/i\]/gi,"</em>");
			rep(/\[u\]/gi,"<u>");
			rep(/\[\/u\]/gi,"</u>");
			rep(/\[s\]/gi,"<s>");
			rep(/\[\/s\]/gi,"</s>");
			rep(/\[sub\]/gi,"<sub>");
			rep(/\[sup\]/gi,"<sup>");
			rep(/\[\/sub\]/gi,"</sub>");
			rep(/\[\/sup\]/gi,"</sup>");
			rep(/\[hr\]/gi,"<hr />");
			rep(/\[\*\]/gi,"<li>");
			rep(/\[list\]/gi,"<ul>");
			rep(/\[\/list\]/gi,"</ul>");
			rep(/\[\/u\]/gi,"</s>");
			rep(/\[url=([^\]]+)\](.*?)\[\/url\]/gi,"<a href=\"$1\">$2</a>");
			rep(/\[url\](.*?)\[\/url\]/gi,"<a href=\"$1\">$1</a>");
			rep(/\[img\](.*?)\[\/img\]/gi,"<img src=\"$1\" />");

			rep(/>\:\(/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/angry.gif\" />");
			rep(/\:\(/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/sad.gif\" />");
			rep(/\?\?\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/huh.gif\" />");
			rep(/\:\:\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/roll.gif\" />");
			rep(/\:D/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/lol.gif\" />");
			rep(/\:K\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/kiss.gif\" />");
			rep(/8\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/cool.gif\" />");
			rep(/\:B/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/blush.gif\" />");
			rep(/\:o/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/shock.gif\" />");
			rep(/\:\-\//gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/undecided.gif\" />");
			rep(/\:X/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/lipsx.gif\" />");
			rep(/\:\'\(/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/cry.gif\" />");
			rep(/\;D/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/grin.gif\" />");
			rep(/\:P/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/tongue.gif\" />");
			rep(/\;\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/wink.gif\" />");
			rep(/\:\)/gi,"<img src=\"" + tinyMCE.activeEditor.getParam('smileyurl') + "/smiley.gif\" />");

			rep(/\[color=(.*?)\](.*?)\[\/color\]/gi,"<font color=\"$1\">$2</font>");
			rep(/\[size=(.*?)\](.*?)\[\/size\]/gi,"<font style=\"font-size: $1"+"px\">$2</font>");
			rep(/\[face=(.*?)\](.*?)\[\/face\]/gi,"<font face=\"$1\">$2</font>");

			//rep(/\[quote=(.*?)\](.*?)\[\/quote\]/gi,"<div class=\"win quotebody\">Quoted from $1<br />$2</div>");
			//rep(/\[quote\](.*?)\[\/quote\]/gi,"<div class=\"win quotebody\">$1</div>");

			rep(/\[center\](.*?)\[\/center\]/gi,"<p align=\"center\">$1</p>");
			rep(/\[right\](.*?)\[\/right\]/gi,"<p align=\"right\">$1</p>");
			rep(/\[justify\](.*?)\[\/justify\]/gi,"<p align=\"justify\">$1</p>");

			return s; 
		}
	});

	// Register plugin
	tinymce.PluginManager.add('bbcode', tinymce.plugins.BBCodePlugin);
})();